'use strict';

/**
 *
 *
 * @author Zhong
 * @date 2019/3/21
 * @version
 */
/*
 * 与产品绑定的信息都可以在此设置
 * */
const mongoose = require('mongoose');
const Schema = mongoose.Schema;
const productSchema = new Schema({
    name: {
        type: String,
        default: '纵横建筑计价'
    },
    company: {
        type: String,
        default: '珠海纵横创新软件有限公司'
    },
    icp: {
        type: String,
        default: '粤ICP备14032472号'
    },
    version: String
}, {versionKey: false});

mongoose.model('product', productSchema, 'product');