/**
 * 工料机类型常量
 *
 * @author CaiAoLin
 * @date 2017/7/7
 * @version
 */

const gljType = {
    LABOUR: 1,                                  // 人工
    // ==============材料类型 ↓=================
    GENERAL_MATERIAL: 201,                      // 普通材料
    CONCRETE: 202,                              // 混凝土
    MORTAR: 203,                                // 砂浆
    MIX_RATIO: 204,                             // 配合比
    COMMERCIAL_CONCRETE: 205,                   // 商品混凝土
    COMMERCIAL_MORTAR: 206,                     // 商品砂浆
    OTHER_MATERIAL: 207,                        // 其它材料
    // ==============材料类型 ↑=================
    // ==============机械类型 ↓=================
    GENERAL_MACHINE: 301,                       // 机械台班
    MACHINE_COMPOSITION: 302,                   // 机械组成物
    MACHINE_LABOUR: 303,                        // 机上人工
    INSTRUMENT: 304,                            // 仪器仪表
    FUEL_POWER_FEE:305,                         // 燃料动力费
    DEPRECIATION_FEE:306,                       // 折旧费
    INSPECTION_FEE:307,                         // 检修费
    MAINTENANCE:308,                            // 维护费
    DISMANTLING_FREIGHT_FEE:309,                // 安拆费及场外运费
    VERIFICATION_FEE:310,                       // 校验费
    OTHER_FEE:311,                              // 其他费用
    OTHER_MACHINE_USED:312,                     // 其他施工机具使用费
    // ==============机械类型 ↑=================
    MAIN_MATERIAL: 4,                           // 主材
    EQUIPMENT: 5,                               // 设备
    MANAGEMENT_FEE: 6,                          // 企业管理费
    PROFIT: 7,                                  // 利润
    GENERAL_RISK_FEE: 8                         // 一般风险费
};

export default gljType;
