/**
 * Created by CSL on 2017-05-18.
 */
//modiyied by zhong on 2017/9/21

$(document).ready(function () {
    let moduleName = 'compleRation';
    function refreshALlWorkBook() {
        if (sectionTreeObj.workBook) {
            sectionTreeObj.workBook.refresh();
        }
        if (rationOprObj.workBook) {
            rationOprObj.workBook.refresh();
        }
        if (rationGLJOprObj.sheet && rationGLJOprObj.sheet.getParent()) {
            rationGLJOprObj.sheet.getParent().refresh();
        }
        if (coeOprObj.workBook) {
            coeOprObj.workBook.refresh();
        }
        if (gljAdjOprObj.workBook) {
            gljAdjOprObj.workBook.refresh();
        }
    }
    //定额章节树与定额表
    let leftElesObj = {};
    leftElesObj.module = moduleName;
    leftElesObj.resize = $('#slideResizeLeft');
    leftElesObj.parent = $('#dataRow');
    leftElesObj.left = $('#leftContent');
    leftElesObj.right = $('#mainContent');
    let maxEval = `$('#zmhsContent').is(':visible') ? $('#dataRow').width() - $('#zmhsContent').width() - 300 : $('#dataRow').width()  - 300`;
    SlideResize.horizontalSlide(leftElesObj, {min: 300, max: maxEval}, function () {
        sectionTreeObj.loadRateWidth();
        refreshALlWorkBook();
    });
    SlideResize.loadHorizonWidth(moduleName, [$('#slideResizeLeft')], [$('#leftContent'), $('#mainContent')], function () {
        //refreshAfterZmhs(false);
        let leftContentWidth = parseFloat($('#leftContent')[0].style.width.replace('%', '')),
            mainContentWidth = parseFloat($('#mainContent')[0].style.width.replace('%', ''));
        let surplus = 100 - leftContentWidth - mainContentWidth;
        $('#leftContent').css('width', `${leftContentWidth + surplus / 2}%`);
        $('#mainContent').css('width', `${mainContentWidth + surplus / 2}%`);
        refreshALlWorkBook();
    });
    //定额表与子目换算表
    let rightElesObj = {};
    rightElesObj.module = moduleName;
    rightElesObj.resize = $('#slideResizeRight');
    rightElesObj.parent = $('#dataRow');
    rightElesObj.left = $('#mainContent');
    rightElesObj.right = $('#zmhsContent');
    let maxEvalRight = `$('#dataRow').width() - $('#leftContent').width() - 200`;
    SlideResize.horizontalSlide(rightElesObj, {min: 200, max: maxEvalRight}, function () {
        refreshALlWorkBook();
    });
    //设置水平拖动条的宽度
    //@param {Object dom}resize滚动条
    function setResizeWidth (resize) {
        const fixedWidth = 10;
        //跟滚动条同层的其他节点
        let bros = resize.parent().children();
        //滚动条节点 及 同层非滚动条节点的索引
        let index = bros.index(resize),
            otherIndex = index ? 0 : 1;
        const other = resize.parent().children(`:eq(${otherIndex})`);
        let resizeParentWidth = resize.parent().width();
        let resizeDecimalWidth = fixedWidth / resizeParentWidth,
            otherDecimalWidth = 1 - resizeDecimalWidth;
        let resizePercentWidth = resizeDecimalWidth * 100 + '%',
            otherPercentWidth = otherDecimalWidth * 100 + '%';
        resize.css('width', resizePercentWidth);
        other.css('width', otherPercentWidth);
    }
    function refreshAfterZmhs(visible) {
        const min = 20;
        //宽度比例localstorage key
        let leftContentKey = `${moduleName}${$('#leftContent').attr('id')}Width`,
            mainContentKey = `${moduleName}${$('#mainContent').attr('id')}Width`,
            zmhsContentKey = `${moduleName}${$('#zmhsContent').attr('id')}Width`;
        let zmhsWidth = getLocalCache(zmhsContentKey) ? getLocalCache(zmhsContentKey) :$('#zmhsContent')[0].style.width,
            mainContentWidth = $('#mainContent')[0].style.width,
            leftContentWidth;
        zmhsWidth = parseFloat(zmhsWidth.replace('%', ''));
        mainContentWidth = parseFloat(mainContentWidth.replace('%', ''));
        if (visible) {
            mainContentWidth = mainContentWidth - zmhsWidth / 2 < min ? min : mainContentWidth - zmhsWidth / 2;
            if (100 - mainContentWidth - zmhsWidth < min) {
                leftContentWidth = min;
                zmhsWidth = 100 - mainContentWidth - leftContentWidth;
            } else {
                leftContentWidth = 100 - mainContentWidth - zmhsWidth;
            }
        } else {
            mainContentWidth += zmhsWidth / 2;
            leftContentWidth = 100 - mainContentWidth;
        }
        $('#leftContent').css('width', `${leftContentWidth}%`);
        setLocalCache(leftContentKey, `${leftContentWidth}%`);
        $('#mainContent').css('width', `${mainContentWidth}%`);
        setLocalCache(mainContentKey, `${mainContentWidth}%`);
        $('#zmhsContent').css('width', `${zmhsWidth}%`);
        setLocalCache(zmhsContentKey, `${zmhsWidth}%`);
        let resizes = [$('#slideResizeLeft'), $('#slideResizeRight')];
        for (let resize of resizes) {
            setResizeWidth(resize);
        }
        sectionTreeObj.loadRateWidth();
    }
    $('#zmhs').click(function () {
        if(!$(this).hasClass('active')){
            $(this).addClass('active');
            refreshAfterZmhs(true);
            $('#zmhsContent').show();
            if(!coeOprObj.workBook){
                pageObj.initPage();
            }
            refreshALlWorkBook();
        } else {
            $(this).removeClass('active');
            refreshAfterZmhs(false);
            $('#zmhsContent').hide();
            refreshALlWorkBook();
        }
    });
    //子目换算和调整表上下拖动
    let zmhsAdjResize = getZmhsAdjResize();
    SlideResize.verticalSlide(zmhsAdjResize.eleObj, zmhsAdjResize.limit, function () {
        if (coeOprObj.workBook) {
            coeOprObj.workBook.refresh();
        }
        if (gljAdjOprObj.workBook) {
            gljAdjOprObj.workBook.refresh();
        }
    });
    loadZmhsAdjSize(zmhsAdjResize);
});
function getZmhsAdjResize() {
    let zmhsAdjResize = {};
    zmhsAdjResize.eleObj = {
        module: 'compleRation',
        resize: $('#zmhsAdjResize'),
        top: $('#mainSpread'),
        topSpread: $('#mainSpread'),
        bottom: $('#contentSpread'),
        bottomSpread: $('#contentSpread')
    };
    zmhsAdjResize.limit = {
        min: 150,
        max: `$(window).height()-$('.header').height()-150-5`,
        totalHeight: `$(window).height()-$('.header').height()-5`,
        notTopSpread: 0,
        notBottomSpread: 0,
    };
    return zmhsAdjResize;
}
function loadZmhsAdjSize(resizeObj) {
    if (!resizeObj) {
        resizeObj = getZmhsAdjResize();
    }
    SlideResize.loadVerticalHeight(resizeObj.eleObj.module, resizeObj.eleObj, resizeObj.limit, function () {
        if (coeOprObj.workBook) {
            coeOprObj.workBook.refresh();
        }
        if (gljAdjOprObj.workBook) {
            gljAdjOprObj.workBook.refresh();
        }
    });
}

var pageObj = {
    initPage: function (){
        let me = this;
        coeOprObj.buildSheet($('#mainSpread')[0]);
        gljAdjOprObj.buildSheet($('#contentSpread')[0]);
        coeOprObj.getCoeList();
        //gljAdjOprObj.getGljItemsOcc();

    },
    showData: function(sheet, setting, data) {
        let me = pageObj, ch = GC.Spread.Sheets.SheetArea.viewport;
        sheet.suspendPaint();
        sheet.suspendEvent();
        sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount(), GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.StorageType.data);
        sheet.setRowCount(data.length + 3);
        for (let col = 0; col < setting.header.length; col++) {
            var hAlign = "left", vAlign = "center";
            if (setting.header[col].hAlign) {
                hAlign = setting.header[col].hAlign;
            } else if (setting.header[col].dataType !== "String"){
                hAlign = "right";
            }
            if(setting.header[col].readOnly){
                sheet.getRange(-1, col, -1, 1).locked(true);
            }
            else{
                sheet.getRange(-1, col, -1, 1).locked(false);
            }
            vAlign = setting.header[col].vAlign?setting.header[col].vAlign:vAlign;
            sheetCommonObj.setAreaAlign(sheet.getRange(-1, col, -1, 1), hAlign, vAlign);
            if (setting.header[col].formatter) {
                sheet.setFormatter(-1, col, setting.header[col].formatter, GC.Spread.Sheets.SheetArea.viewport);
            }
            for (let row = 0; row < data.length; row++) {
                let val = data[row][setting.header[col].dataCode];
                sheet.setValue(row, col, val, ch);
            }
        }
        sheet.resumeEvent();
        sheet.resumePaint();
    }
};

let coeOprObj = {
    workBook: null,
    workSheet: null,
    currentCoeList: [],
    currentCoe: null,
    currentMaxNo: null,
    setting: {
        header: [
            {headerName:"编号", headerWidth:50, dataCode:"serialNo", dataType: "String", hAlign: "center", vAlign: "center", readOnly: false},
            {headerName:"名称", headerWidth:280, dataCode:"name", dataType: "String", hAlign: "left", vAlign: "center", readOnly: false},
            {headerName:"内容", headerWidth:150, dataCode:"content", dataType: "String", hAlign: "left", vAlign: "center", readOnly: false},
        ]
    },
    buildSheet: function (container) {
        let me = coeOprObj;
        me.workBook = sheetCommonObj.buildSheet(container, me.setting, 30);
        sheetCommonObj.bindEscKey(me.workBook, [{sheet: me.workBook.getSheet(0), editStarting: null, editEnded: me.onEditEnded}]);
        me.workSheet = me.workBook.getSheet(0);
        me.workSheet.options.isProtected = true;
        me.onDelOpr(me.workBook, me.setting);
        me.workSheet.bind(GC.Spread.Sheets.Events.SelectionChanged, me.onSelectionChanged);
        me.workSheet.bind(GC.Spread.Sheets.Events.EditEnded, me.onEditEnded);
        me.workBook.bind(GC.Spread.Sheets.Events.ClipboardPasting, me.onClipboardPasting);
        me.workBook.bind(GC.Spread.Sheets.Events.ClipboardPasted, me.onClipboardPasted);
    },
    onSelectionChanged: function (sender, info) {
        let me = coeOprObj, that = gljAdjOprObj;
        if(info.oldSelections.length === 0 && info.newSelections.length > 0 || info.oldSelections[0].row !== info.newSelections[0].row){
            let row = info.newSelections[0].row;
            if(row < me.currentCoeList.length){
                me.currentCoe = me.currentCoeList[row];
                that.currentGljAdjList = me.currentCoe.coes;
                that.buildDynamicComboBox(that.workSheet);
            }
            else{
                me.currentCoe = null;
                that.currentGljAdjList = [];
                that.buildBaseCell(that.workSheet);
            }
            //refresh & show coes
            sheetCommonObj.cleanSheet(that.workSheet, that.setting, -1);
            me.workBook.focus(true);
            that.show(that.currentGljAdjList);
        }
    },
    onEditEnded: function (sender, args) {
        let me = coeOprObj, addArr = [], updateArr = [], dataCode = me.setting.header[args.col].dataCode;
        if(args.editingText && args.editingText.toString().trim().length > 0){
            let inputT = args.editingText.toString().trim();
            //update
            if(args.row < me.currentCoeList.length){
                let updateObj = me.currentCoeList[args.row];
                if(updateObj[dataCode] != inputT){
                    if(dataCode === 'serialNo'){
                        if(me.isInt(inputT) && !me.hasTisNo(me.currentCoeList, inputT)){
                            me.currentMaxNo = me.currentMaxNo >= inputT ? me.currentMaxNo : inputT;
                            updateObj[dataCode] = inputT;
                            updateArr.push(updateObj);
                            me.save([], updateArr, [], true);
                        }
                        else if(!me.isInt(inputT)){
                            alert('编号只能为整数！');
                            args.sheet.setValue(args.row, args.col, updateObj[dataCode] + '');
                        }
                        else if(me.hasTisNo(me.currentCoeList, inputT)){
                            alert('该编号已存在！');
                            args.sheet.setValue(args.row, args.col, updateObj[dataCode] + '');
                        }
                    }
                    else {
                        updateObj[dataCode] = inputT;
                        updateArr.push(updateObj);
                        me.save([], updateArr, [], true);
                    }
                }
            }
            //insert
            else{
                let newCoe = {};
                if(dataCode === 'serialNo'){
                    if(me.isInt(inputT) && !me.hasTisNo(me.currentCoeList, inputT)){
                        me.currentMaxNo = me.currentMaxNo >= inputT ? me.currentMaxNo : inputT;
                        newCoe[dataCode] = inputT;
                        addArr.push(newCoe);
                        me.save(addArr, [], [], true, function (result) {
                            me.updateCurrentCoeList(result);
                        });
                    }
                    else if(!me.isInt(inputT)){
                        args.sheet.setValue(args.row, args.col, '');
                        alert('编号只能为整数！');
                    }
                    else if(me.hasTisNo(me.currentCoeList, inputT)){
                        args.sheet.setValue(args.row, args.col, '');
                        alert('该编号已存在！');
                    }
                }
                else{
                    newCoe.serialNo = ++me.currentMaxNo;
                    newCoe[dataCode] = inputT;
                    addArr.push(newCoe);
                    me.save(addArr, [], [], true, function (result) {
                        me.updateCurrentCoeList(result);
                    });
                }
            }
        }
    },
    onClipboardPasting: function (sender, info) {
        let me = coeOprObj, maxCol = info.cellRange.col + info.cellRange.colCount - 1;
        if(maxCol > me.setting.header.length){
            info.cancel = true;
        }
    },
    onClipboardPasted: function (sender, info) {
        let me = coeOprObj, addArr = [], updateArr = [];
        let items = sheetCommonObj.analyzePasteData(me.setting, info);
        let uniqItems = me.makeUniqItems(items);
        for(let i = 0, len = uniqItems.length; i < len; i++){
            let row = i + info.cellRange.row;
            //update
            if(row < me.currentCoeList.length){
                let updateObj = me.currentCoeList[row];
                for(let attr in uniqItems[i]){
                    if(attr === 'serialNo'){
                        if(me.isInt(uniqItems[i][attr]) && !me.hasTisNo(me.currentCoeList, uniqItems[i][attr])){
                            me.currentMaxNo = me.currentMaxNo >= uniqItems[i][attr] ? me.currentMaxNo : uniqItems[i][attr];
                            updateObj[attr] = uniqItems[i][attr];
                        }
                    }
                    else {
                        updateObj[attr] = uniqItems[i][attr];
                    }
                }
                updateArr.push(updateObj);
            }
            //insert
            else {
                if(typeof uniqItems[i].serialNo !== 'undefined' && uniqItems[i] && me.isInt(uniqItems[i].serialNo) && !me.hasTisNo(me.currentCoeList, uniqItems[i].serialNo)){
                    me.currentMaxNo = me.currentMaxNo >= uniqItems[i].serialNo ? me.currentMaxNo : uniqItems[i].serialNo;
                }
                else {
                    uniqItems[i].serialNo = ++me.currentMaxNo;
                }
                addArr.push(uniqItems[i]);
            }
        }
        if(addArr.length > 0 || updateArr.length > 0){
            me.save(addArr, updateArr, [], true, function (result) {
                me.updateCurrentCoeList(result);
            });
        }
    },
    onDelOpr: function (workBook, setting) {
        let me = coeOprObj, that = gljAdjOprObj;
        workBook.commandManager().register('coeListDel', function () {
            let deleteArr = [];
            let sheet = workBook.getSheet(0);
            let sels = sheet.getSelections();
            let idx = sels[0].row;
            for(let i = 0, len = sels.length; i < len; i++){
                if(idx > sels[i].row){
                    idx = sels[i].row;
                }
                if(sels[i].colCount === setting.header.length){//can del
                    for(let r = 0, rLen = sels[i].rowCount; r < rLen; r++){
                        let row = sels[i].row + r;
                        if(row < me.currentCoeList.length){
                            deleteArr.push({userId: me.currentCoeList[row].userId, compilationId: me.currentCoeList[row].compilationId, ID: me.currentCoeList[row].ID});
                        }
                    }
                    me.currentCoeList.splice(sels[i].row, sels[i].rowCount);
                }
            }
            if(deleteArr.length > 0){
                me.save([], [], deleteArr, true);
                me.currentCoe = typeof me.currentCoeList[idx] !== 'undefined' ? me.currentCoeList[idx] : null;
                that.currentGljAdjList = me.currentCoe ? me.currentCoe.coes : [];
                gljAdjOprObj.show(that.currentGljAdjList);
            }

        });
        workBook.commandManager().setShortcutKey(null, GC.Spread.Commands.Key.del, false, false, false, false);
        workBook.commandManager().setShortcutKey('coeListDel', GC.Spread.Commands.Key.del, false, false, false, false);
    },
    //粘贴的数据，编号唯一化，去除编号重复的项
    makeUniqItems: function (items) {
        let rst = [];
        for(let i = 0, len = items.length; i < len; i++){
            if(typeof items[i].serialNo !== 'undefined' && items[i].serialNo){
                if(rst.length === 0){
                    rst.push(items[i]);
                }
                else{
                    let isExist = false;
                    for(let j = 0, jLen = rst.length; j < jLen; j++){
                        if(items[i].serialNo === rst[j].serialNo){
                            isExist = true;
                            break;
                        }
                    }
                    if(!isExist){
                        rst.push(items[i]);
                    }
                }
            }
            else {
                rst.push(items[i]);
            }
        }
        return rst;
    },
    isInt: function (num) {
        return !isNaN(num) && num % 1 === 0;
    },
    hasTisNo: function (coeList, newSerialNo) {
        let rst = false;
        for(let i = 0, len = coeList.length; i < len; i++){
            if(coeList[i].serialNo == newSerialNo){
                rst = true;
                break;
            }
        }
        return rst;
    },
    updateCurrentCoeList: function (newCoeList) {
        let me = coeOprObj;
        if(newCoeList){
            me.currentCoeList = me.currentCoeList.concat(newCoeList);
        }
    },
    sortCoeList: function (coeList) {
        coeList.sort(function (a, b) {
            let rst = 0;
            if(a.serialNo > b.serialNo) rst = 1;
            else if(a.serialNo < b.serialNo) rst = -1;
            return rst;
        });
    },
    getCoeList: function () {
        let me = coeOprObj;
        $.ajax({
            type: 'post',
            url: 'api/getCoeList',
            dataType: 'json',
            timeout:20000,
            success: function (result) {
                if(!result.error){
                    me.currentCoeList = result.data;
                    me.sortCoeList(me.currentCoeList);
                    me.currentMaxNo =  me.currentCoeList.length > 0 ? me.currentCoeList[me.currentCoeList.length - 1].serialNo : 0;
                    pageObj.showData(me.workSheet, me.setting, me.currentCoeList);
                    me.workSheet.clearSelection();
                }
            },
            error:function(err){
                alert("内部程序错误！");
            }
        });
    },
    save: function (addArr, updateArr, deleteArr, refresh, callback) {
        let me = coeOprObj;
        $.ajax({
            type:"POST",
            url:"api/saveCoeList",
            data: {data: JSON.stringify({addArr: addArr, updateArr: updateArr, deleteArr: deleteArr})},
            dataType:"json",
            timeout:5000,
            success:function(result){
                if (result.error) {
                    alert(result.message);
                } else{
                    if(callback){
                        callback(result.data);
                    }
                    if(refresh){
                        me.sortCoeList(me.currentCoeList);
                        me.currentMaxNo = me.currentCoeList.length > 0 ? me.currentCoeList[me.currentCoeList.length - 1].serialNo : 0;
                        pageObj.showData(me.workSheet, me.setting, me.currentCoeList);
                    }
                }
            },
            error:function(err){
                alert("内部程序错误！");
            }
        });
    }
};

let gljAdjOprObj = {
    workBook: null,
    workSheet: null,
    currentGljAdjList: [],
    gljList: [],//总工料机列表, gljSelect中获取
    setting: {
        header: [
            {headerName:"调整类型", headerWidth:80, dataCode:"coeType", dataType: "String", hAlign: "center", vAlign: "center", readOnly: false},
            {headerName:"人材机编码", headerWidth:80, dataCode:"gljCode", dataType: "String", formatter: '@', hAlign: "center", vAlign: "center", readOnly: false},
            {headerName:"名称", headerWidth:100, dataCode:"gljName", dataType: "String", hAlign: "center", vAlign: "center", readOnly: true},
            {headerName:"操作符", headerWidth:60, dataCode:"operator", dataType: "String", hAlign: "center", vAlign: "center", readOnly: false},
            {headerName:"数量", headerWidth:80, dataCode:"amount", dataType: "String", hAlign: "center", vAlign: "center" , readOnly: false},
        ],
        comboItems: {
            //调整类型下拉菜单
            coeType: ['定额', '人工', '材料', '机械', '主材', '设备', '单个工料机'],
            //操作符下拉菜单
            operator: ['+', '-', '*', '/', '=']
        }
    },
    buildSheet: function (container) {
        let me = gljAdjOprObj;
        me.workBook = sheetCommonObj.buildSheet(container, me.setting, 3);
        me.workSheet = me.workBook.getSheet(0);
        sheetCommonObj.bindEscKey(me.workBook, [{sheet: me.workBook.getSheet(0), editStarting: me.onEditStart, editEnded: me.onEditEnded}]);
        me.workSheet.options.isProtected = true;
        me.onDelOpr(me.workBook, me.setting);
        me.workSheet.clearSelection();
        me.workSheet.bind(GC.Spread.Sheets.Events.EditStarting, me.onEditStart);
        me.workSheet.bind(GC.Spread.Sheets.Events.EditEnded, me.onEditEnded);
        me.workSheet.bind(GC.Spread.Sheets.Events.EnterCell, me.onEnterCell);
        me.workSheet.bind(GC.Spread.Sheets.Events.ClipboardPasting, me.onClipboardPasting);
        me.workSheet.bind(GC.Spread.Sheets.Events.ClipboardPasted, me.onClipboardPasted);
    },
    buildBaseCell: function (sheet) {
        let me = gljAdjOprObj;
        sheet.suspendPaint();
        sheet.suspendEvent();
        let baseCell = GC.Spread.Sheets.CellTypes.Base();
        sheet.getCell(-1, 0).cellType(baseCell);
        sheet.getCell(-1, 3).cellType(baseCell);
        sheet.resumePaint();
        sheet.resumeEvent();
    },
    buildDynamicComboBox: function (sheet) {
        let me = gljAdjOprObj;
        sheet.suspendPaint();
        sheet.suspendEvent();
        let dynamicCombo = sheetCommonObj.getDynamicCombo();
        dynamicCombo.items(me.setting.comboItems.coeType);
        let dynamicOprCombo = sheetCommonObj.getDynamicCombo();
        dynamicOprCombo.items(me.setting.comboItems.operator);
        sheet.getCell(-1, 0).cellType(dynamicCombo);
        sheet.getCell(-1, 3).cellType(dynamicOprCombo);
        sheet.resumePaint();
        sheet.resumeEvent();
    },
    onEnterCell: function (sender, args) {
        args.sheet.repaint();
    },
    onEditStart: function (sender, args) {
        let me = gljAdjOprObj;
        if(!coeOprObj.currentCoe || args.row >= me.currentGljAdjList.length && args.col === 1
            || args.row < me.currentGljAdjList.length && args.col === 1 && me.currentGljAdjList[args.row].coeType !== '单个工料机'){
            args.cancel = true;
        }
    },
    onEditEnded: function (sender, args) {
        let me = gljAdjOprObj, isUpdate = false,
            dataCode = me.setting.header[args.col].dataCode;
        if(args.editingText && args.editingText.toString().trim().length > 0){
            if(dataCode === 'amount' &&  isNaN(args.editingText)){
                alert("只能输入数值！");
                args.sheet.setValue(args.row, args.col, typeof me.currentGljAdjList[args.row] !== 'undefined' && typeof me.currentGljAdjList[args.row][dataCode] !== 'undefined'
                    ? me.currentGljAdjList[args.row][dataCode] + '' : '');
            }
            else {
                //update
                if(args.row < me.currentGljAdjList.length && args.editingText.toString().trim() !== me.currentGljAdjList[args.row][dataCode]){
                    let updateObj = me.currentGljAdjList[args.row];
                    if(dataCode === 'gljCode' && typeof updateObj.coeType !== 'undefined' && updateObj.coeType === '单个工料机'){
                        let gljName = me.getGljName(args.editingText, me.gljList);
                        if(gljName){
                            updateObj.gljCode = args.editingText;
                            updateObj.gljName = gljName;
                            isUpdate = true;
                        }
                        else {
                            alert("不存在编号为"+ args.editingText +"的工料机");
                        }
                    }
                    else if(dataCode === 'coeType'){
                        isUpdate = true;
                        updateObj[dataCode] = args.editingText;
                        updateObj.gljCode = '';
                        updateObj.gljName = '';
                    }
                    else if(dataCode !== 'gljCode') {
                        isUpdate = true;
                        updateObj[dataCode] = args.editingText;
                    }
                }
                //insert
                else if(args.row >= me.currentGljAdjList.length){
                    isUpdate = true;
                    let newAdjGlj = {};
                    newAdjGlj[dataCode] = args.editingText;
                    me.currentGljAdjList.push(newAdjGlj);
                }
                if(isUpdate){
                    coeOprObj.save([], [coeOprObj.currentCoe], [], false, function () {
                        console.log(me.currentGljAdjList);
                        me.show(me.currentGljAdjList);
                    });
                }
                else {
                    args.sheet.setValue(args.row, args.col, typeof me.currentGljAdjList[args.row] !== 'undefined' && typeof me.currentGljAdjList[args.row][dataCode] !== 'undefined'
                        ? me.currentGljAdjList[args.row][dataCode] + '' : '');
                }
            }
        }
    },
    onClipboardPasting: function (sender, info) {

    },
    getValidPasteDatas: function (pasteItems, info) {
        let me = gljAdjOprObj;
        let rst = [];
        for(let i = 0, len = pasteItems.length; i < len; i++){
            let row = i + info.cellRange.row;
            let validObj = {};
            //update
            if(row < me.currentGljAdjList.length){
                let updateObj = me.currentGljAdjList[row];
                if(typeof pasteItems[i].coeType !== 'undefined' && typeof pasteItems[i].gljCode !== 'undefined'){
                    let gljName = me.getGljName(pasteItems[i].gljCode, me.gljList);
                    if(pasteItems[i].coeType === '单个工料机' && gljName){
                        validObj.coeType = pasteItems[i].coeType;
                        validObj.gljCode = pasteItems[i].gljCode;
                        validObj.gljName = gljName;
                    }
                    else if(pasteItems[i].coeType !== '单个工料机' && me.setting.comboItems.coeType.indexOf(pasteItems[i].coeType) !== -1){
                        validObj.coeType = pasteItems[i].coeType;
                    }
                }
                else if(typeof pasteItems[i].coeType === 'undefined' && typeof pasteItems[i].gljCode !== 'undefined'){
                    let gljName = me.getGljName(pasteItems[i].gljCode, me.gljList);
                    if(typeof updateObj.coeType !== 'undefined' && updateObj.coeType === '单个工料机' && gljName){
                        validObj.gljCode = pasteItems[i].gljCode;
                        validObj.gljName = gljName;
                    }
                }
                else if(typeof pasteItems[i].coeType !== 'undefined' && typeof pasteItems[i].gljCode === 'undefined'){
                    if(me.setting.comboItems.coeType.indexOf(pasteItems[i].coeType) !== -1){
                        validObj.coeType = pasteItems[i].coeType;
                        if(validObj.coeType !== '单个工料机' && typeof updateObj.gljCode !== '单个工料机' && updateObj.gljCode.toString().trim().length > 0){
                            validObj.gljCode = '';
                            validObj.gljName = '';
                        }
                    }
                }
                else {
                    if(typeof pasteItems[i].operator !== 'undefined' && me.setting.comboItems.operator.indexOf(pasteItems[i].operator) !== -1){
                        validObj.operator = pasteItems[i].operator;
                    }
                    if(typeof pasteItems[i].amount !== 'undefined' && !isNaN(pasteItems[i].amount)){
                        validObj.amount = pasteItems[i].amount;
                    }
                }
            }
            else {
                if(typeof pasteItems[i].coeType !== 'undefined' && typeof pasteItems[i].gljCode !== 'undefined'){
                    let gljName = me.getGljName(pasteItems[i].gljCode, me.gljList);
                    if(pasteItems[i].coeType === '单个工料机' && gljName){
                        validObj.coeType = pasteItems[i].coeType;
                        validObj.gljCode = pasteItems[i].gljCode;
                        validObj.gljName = gljName;
                    }
                    else if(pasteItems[i].coeType !== '单个工料机' && me.setting.comboItems.coeType.indexOf(pasteItems[i].coeType) !== -1){
                        validObj.coeType = pasteItems[i].coeType;
                    }
                }
                else if(typeof pasteItems[i].gljCode === 'undefined') {
                    if(typeof pasteItems[i].coeType !== 'undefined' && me.setting.comboItems.coeType.indexOf(pasteItems[i].coeType) !== -1){
                        validObj.coeType = pasteItems[i].coeType;
                    }
                    if(typeof pasteItems[i].operator !== 'undefined' && me.setting.comboItems.operator.indexOf(pasteItems[i].operator) !== -1){
                        validObj.operator = pasteItems[i].operator;
                    }
                    if(typeof pasteItems[i].amount !== 'undefined' && !isNaN(pasteItems[i].amount)){
                        validObj.amount = pasteItems[i].amount;
                    }
                }
            }
            if(Object.keys(validObj).length > 0){
                rst.push(validObj);
            }
        }
        return rst;
    },
    onClipboardPasted: function (sender, info) {
        let me = gljAdjOprObj, row;
        let items = sheetCommonObj.analyzePasteData(me.setting, info);
        let validDatas = me.getValidPasteDatas(items, info);
        for(let i = 0, len = validDatas.length; i < len; i++){
            row = i + info.cellRange.row;
            //update
            if(row < me.currentGljAdjList.length){
                let updateObj = me.currentGljAdjList[row];
                for(let attr in validDatas[i]){
                    updateObj[attr] = validDatas[i][attr];
                }
            }
            //insert
            else{
                me.currentGljAdjList.push(validDatas[i]);
            }
        }
        if(validDatas.length > 0){
            coeOprObj.save([], [coeOprObj.currentCoe], [], false, function () {
                me.show(me.currentGljAdjList);
            });
        }
        else {
            me.show(me.currentGljAdjList);
        }
    },
    onDelOpr: function (workBook, setting) {
        let me = gljAdjOprObj;
        workBook.commandManager().register('gljAdjDel', function () {
            let sheet = workBook.getSheet(0);
            let sels = sheet.getSelections();
            let isUpdate = false;
            for(let i = 0, len = sels.length; i < len; i++){
                if(sels[i].colCount === setting.header.length){//can del
                    if(sels[i].row < me.currentGljAdjList.length){
                        isUpdate = true;
                        me.currentGljAdjList.splice(sels[i].row, sels[i].rowCount);
                    }
                }
            }
            if(isUpdate){
                coeOprObj.save([], [coeOprObj.currentCoe], [], false, function () {
                    me.show(me.currentGljAdjList);
                });
            }
        });
        workBook.commandManager().setShortcutKey(null, GC.Spread.Commands.Key.del, false, false, false, false);
        workBook.commandManager().setShortcutKey('gljAdjDel', GC.Spread.Commands.Key.del, false, false, false, false);
    },
    getGljName: function (gljCode, gljList) {
        let rst = null;
        for(let i = 0, len = gljList.length; i < len; i++){
            if(gljCode === gljList[i].code){
                rst = gljList[i].name;
                break;
            }
        }
        return rst;
    },
    show: function (coes) {
        let me = gljAdjOprObj;
        pageObj.showData(me.workSheet, me.setting, coes)
    },
    getGljItemsOcc: function () {
        let me = gljAdjOprObj;
        $.ajax({
            type: 'post',
            url: '/stdGljRepository/api/getGljItemsOccupied',
            data: {repId: pageObj.gljLibID, occupation: '-_id code name'},
            dataType: 'json',
            timeout: 5000,
            success:function(result){
                if (result.error) {
                    alert(result.message);
                } else{
                    me.gljList = result.data;
                }
            },
            error:function(err){
                alert("内部程序错误！");
            }
        });
    }
};

