/**
 * Created by zhang on 2017/9/27.
 */

module.exports = {
    version:'1.0.2',
    common_jspaths:[
        'lib/jquery/jquery-3.2.1.min.js',
        'lib/jquery-ui/jquery-ui.min.js',
        'lib/popper/popper.min.js',
        'lib/bootstrap/bootstrap.min.js',
        'lib/bootstrap/bootstrap-submenu.js',
        'web/building_saas/js/*.js',
        'public/common_util.js',
        'public/web/scMathUtil.js',
        'public/web/gljUtil.js',
        'public/web/PerfectLoad.js',
        'lib/lodash/lodash.js',
        'public/web/commonAlert.js',
        'public/web/headerOpr.js',
        'lib/jquery-editable-select/jquery.editable-select.min.js'
    ],
    common_css:[
        'lib/jquery-ui/jquery-ui.css',
        'lib/bootstrap/css/bootstrap.min.css',
        'lib/bootstrap/css/bootstrap-submenu.js',
        'lib/spreadjs/sheets/css/gc.spread.sheets.sc.css',
        'web/building_saas/css/main.css',
        'web/building_saas/css/custom.css',
        'lib/font-awesome/font-awesome.min.css',
        'lib/jquery-editable-select/jquery.editable-select.min.css'
    ],
    login_jspaths:[
        'public/web/url_util.js',
        'web/users/js/gt.js',
        'web/users/js/login.js'
    ],
    pm_css:[
        'lib/ztree/css/zTreeStyle.css',
        'lib/jquery-contextmenu/jquery.contextMenu.css'
    ],
    pm_jspaths:[
        'public/web/uuid.js',
        'public/web/date_util.js',
        'public/web/id_tree.js',
        'public/web/tree_sheet/tree_sheet_helper.js',
        'public/web/sheet/sheet_data_helper.js',
        'public/web/sheet/sheet_common.js',
        'public/web/common_ajax.js',
        'lib/JSExpressionEval_src/Date.js',
        'web/building_saas/glj/js/socket.io.slim.js',
        'public/web/socket/connection.js',
        'public/billsUtil.js',
        'web/building_saas/main/js/models/importStandardInterface.js',
        'web/building_saas/pm/js/**/*.js',
        'lib/ztree/*.js',
        'lib/jquery-contextmenu/jquery.contextMenu.min.js'
    ],
    main_css:[
        'lib/ztree/css/zTreeStyle.css',
        //'lib/jquery-ui/jquery-ui.css',
        //'lib/spreadjs/sheets/css/gc.spread.sheets.sc.css',
        'lib/jquery-contextmenu/jquery.contextMenu.css'
    ],
    main_jspaths:[
        'lib/JSExpressionEval_src/*.js',
        '!lib/JSExpressionEval_src/JsHashMap.js',
       /* 'lib/jquery-ui/jquery-ui.min.js',
        'lib/jquery-ui/jquery-ui-datepickerCN.js',
        'lib/jquery-contextmenu/!*.js',*/
        //'lib/lodash/lodash.js',
        // 'test/tmp_data/test_ration_calc/ration_calc_base.js',
        'web/building_saas/main/js/models/main_consts.js',
        'web/over_write/config/compilation_config.js',
        'public/web/common_util.js',
        'web/building_saas/glj/js/project_glj.js',
        'web/building_saas/glj/js/composition.js',
        'web/building_saas/glj/js/common_spread.js',
        'web/building_saas/glj/js/composition_spread.js',
        'web/building_saas/glj/js/project_glj_spread.js',
        'web/building_saas/glj/js/socket.io.slim.js',
        'public/web/socket/connection.js',
        'public/web/uuid.js',
        'public/web/sheet/sheet_common.js',
        'web/building_saas/main/js/models/calc_program.js',
        'web/building_saas/main/js/models/calc_base.js',
        'web/building_saas/main/js/views/calc_program_manage.js',
        'public/web/common_ajax.js',
        'public/web/url_util.js',
        'public/web/number_util.js',
        'public/web/sheet/sheet_common.js',
        'public/web/slideResize.js',
       // 'lib/ztree/*.js',
        'lib/spreadjs/sheets/gc.spread.sheets.all.11.1.2',
       // 'lib/spreadjs/views/gc.spread.views.dataview.10.0.0.min.js',
       // "lib/spreadjs/views/common/gc.spread.common.10.0.0.min.js",
      //  'lib/spreadjs/views/plugins/gc.spread.views.gridlayout.10.0.0.min.js',
        'web/building_saas/main/js/models/project.js',
        'web/building_saas/main/js/models/bills.js',
        'web/building_saas/main/js/models/ration.js',
        'web/building_saas/main/js/models/glj.js',
        'web/building_saas/main/js/models/project_glj.js',
        'web/building_saas/main/js/models/composition.js',
        'web/building_saas/main/js/models/fee_rate.js',
        'web/building_saas/main/js/models/ration_glj.js',
        'web/building_saas/main/js/models/ration_coe.js',
        'web/building_saas/main/js/models/ration_ass.js',
        'web/building_saas/main/js/models/ration_installation.js',
        'web/building_saas/main/js/models/ration_template.js',
        // 'web/building_saas/main/js/models/volume_price.js',
        'web/building_saas/main/js/models/labour_coe.js',
        'web/building_saas/main/js/models/installation_fee.js',
        'public/web/id_tree.js',
        'web/building_saas/main/js/models/cache_tree.js',
        'web/building_saas/main/js/calc/calc_fees.js',
        'web/building_saas/main/js/models/exportStdInterfaceBase.js',
        'web/building_saas/main/js/models/exportStandardInterface.js',
        'web/building_saas/main/js/models/exportSEIInterface.js',
        'web/building_saas/main/js/models/overHeight.js',
        // 'web/building_saas/main/js/calc/ration_calc.js',
        // 'web/building_saas/main/js/calc/bills_calc.js',
        // 'public/calc_util.js',
        'public/web/tree_sheet/tree_sheet_controller.js',
        'public/web/tree_sheet/tree_sheet_helper.js',
        'public/web/sheet/sheet_data_helper.js',
        'web/building_saas/main/js/views/glj_col.js',
        'web/building_saas/main/js/views/main_tree_col.js',
        'web/building_saas/main/js/views/project_info.js',
        'web/building_saas/main/js/views/export_view.js',
        'web/building_saas/main/js/views/project_view.js',
        'web/building_saas/main/js/views/options_view.js',
        'web/building_saas/main/js/views/project_property_bills_quantity_decimal.js',
        'web/building_saas/main/js/views/project_property_decimal_view.js',
        'web/building_saas/main/js/views/project_property_basicInfo.js',
        'web/building_saas/main/js/views/project_property_projFeature.js',
        'web/building_saas/main/js/views/project_property_indicativeInfo.js',
        'web/building_saas/main/js/views/project_property_display_view.js',
        'web/building_saas/main/js/main_ajax.js',
        'web/building_saas/main/js/main.js',
        'web/building_saas/main/js/controllers/project_controller.js',
        'web/building_saas/main/js/controllers/block_controller.js',
        'web/building_saas/main/js/controllers/material_controller.js',
        'web/building_saas/main/js/views/side_tools.js',
        'web/building_saas/main/js/views/std_billsGuidance_lib.js',
        'web/building_saas/main/js/views/std_bills_lib.js',
        'web/building_saas/main/js/views/std_ration_lib.js',
        'web/building_saas/main/js/views/block_lib.js',
        'web/building_saas/main/js/models/quantity_detail.js',
        'web/building_saas/main/js/views/glj_view_contextMenu.js',
        'web/building_saas/main/js/views/calc_program_view.js',
        'web/building_saas/main/js/views/confirm_modal.js',
        'web/building_saas/main/js/views/zlfb_view.js',
        'web/building_saas/main/js/views/installation_fee_view.js',
        'web/building_saas/main/js/views/material_adjust_view.js',
        'web/building_saas/main/js/views/config_material_view.js',
        'web/building_saas/main/js/views/index_view.js',
        'web/building_saas/main/js/views/project_glj_view.js',
        'web/building_saas/main/js/views/importBills.js',
        'public/web/rpt_tpl_def.js',
        'public/web/treeDataHelper.js',
        'public/web/string_util_light.js',
        'public/web/ztree_common.js',
        'web/building_saas/report/js/rpt_jspdf.js',
        'web/building_saas/report/js/rpt_main.js',
        'web/building_saas/report/js/rpt_cfg_const.js',
        'web/building_saas/report/js/jpc_output_value_define.js',
        'web/building_saas/report/js/jpc_output.js',
        'web/building_saas/report/js/rpt_print.js',
        'web/building_saas/main/js/views/character_content_view.js',
        'web/building_saas/main/js/views/glj_view.js',
        'web/building_saas/main/js/views/zmhs_view.js',
        'web/building_saas/main/js/views/mbzm_view.js',
        'web/building_saas/main/js/views/tender_price_view.js',
        'web/building_saas/main/js/views/billsElf.js',
        'web/building_saas/main/js/views/sub_view.js',
        'web/building_saas/main/js/views/fee_rate_view.js',
        'web/building_saas/main/js/views/quantity_edit_view.js',
        'web/building_saas/main/js/views/sub_fee_rate_views.js',
        'web/building_saas/main/js/views/calc_base_view.js',
        'web/building_saas/main/js/views/project_property_labour_coe_view.js',
        'web/building_saas/main/js/views/locate_view.js',
        'web/building_saas/complementary_ration_lib/js/main.js',
        'public/web/storageUtil.js'
    ],
    compleGlj_css: [
        'lib/jquery-contextmenu/jquery.contextMenu.css',
        'lib/ztree/css/zTreeStyle.css',
    ],
    compleGlj_jspaths: [
        'public/web/common_ajax.js',
        'public/web/treeDataHelper.js',
        'public/web/QueryParam.js',
        'lib/lodash/lodash.js',
        'public/web/id_tree.js',
        'public/web/tree_sheet/tree_sheet_controller.js',
        'public/web/tree_sheet/tree_sheet_helper.js',
        'public/web/tools_const.js',
        'public/web/ration_glj_units.js',
        'web/building_saas/complementary_glj_lib/js/glj.js',
        'web/building_saas/complementary_glj_lib/js/gljClassTree.js',
        'web/building_saas/complementary_glj_lib/js/gljComponent.js',
        'web/building_saas/complementary_glj_lib/js/components.js',
        'public/web/ztree_common.js',
        'public/web/sheet/sheet_common.js',
        'web/building_saas/complementary_glj_lib/js/sheetOpr.js',
        'public/web/storageUtil.js',
        'public/web/slideResize.js'
    ],
    compleRation_ration_css: [
        'lib/ztree/css/zTreeStyle.css',
        'lib/jquery-contextmenu/jquery.contextMenu.css',
    ],
    compleRation_ration_jspaths:[
        '/public/web/uuid.js',
        'lib/jquery-contextmenu/jquery.contextMenu.min.js',
        'lib/jquery-contextmenu/jquery.ui.position.js',
        'lib/ztree/jquery.ztree.core.js',
        'web/building_saas/complementary_ration_lib/js/global.js',
        'public/web/id_tree.js',
        'public/web/tree_sheet/tree_sheet_controller.js',
        'public/web/tree_sheet/tree_sheet_helper.js',
        'public/web/treeDataHelper.js',
        'public/web/sheet/sheet_common.js',
        'public/web/sheet/sheet_data_helper.js',
        'web/building_saas/complementary_ration_lib/js/sheetsOpr.js',
        'public/web/QueryParam.js',
        'public/web/storageUtil.js',
        'web/building_saas/complementary_ration_lib/js/section_tree.js',
        'web/building_saas/complementary_ration_lib/js/explanatory.js',
        'web/building_saas/complementary_ration_lib/js/jobContent.js',
        'web/building_saas/complementary_ration_lib/js/annotation.js',
        'public/web/scMathUtil.js',
        'public/web/common_ajax.js',
        'public/web/ztree_common.js',
        'public/web/ration_glj_units.js',
        'web/building_saas/complementary_ration_lib/js/ration.js',
        'web/building_saas/complementary_ration_lib/js/gljSelect.js',
        'web/building_saas/complementary_ration_lib/js/ration_glj.js',
        'web/building_saas/complementary_ration_lib/js/ration_coe.js',
        'web/building_saas/complementary_ration_lib/js/ration_assist.js',
        'web/building_saas/complementary_ration_lib/js/ration_installation.js.js',
        'public/web/slideResize.js',
        'web/building_saas/complementary_ration_lib/js/coe.js',
        'web/building_saas/complementary_ration_lib/js/init.js'
    ],
    compleRation_glj_css: [
    ],
    compleRation_glj_jspaths: [
        'web/building_saas/complementary_ration_lib/js/global.js',
        'public/web/common_ajax.js',
        'public/web/treeDataHelper.js',
        'public/web/QueryParam.js',
        'web/building_saas/complementary_ration_lib/js/repository_glj.js',
        'public/web/ztree_common.js',
        'public/web/sheet/sheet_common.js',
        'web/building_saas/complementary_ration_lib/js/sheetsOpr.js',
        'public/web/storageUtil.js'
    ],
    compleRation_coe_css: [
    ],
    compleRation_coe_jspaths: [
        'web/building_saas/complementary_ration_lib/js/global.js',
        'public/web/common_ajax.js',
        'public/web/treeDataHelper.js',
        'public/web/QueryParam.js',
        'public/web/common_util.js',
        'public/web/sheet/sheet_common.js',
        'web/building_saas/complementary_ration_lib/js/sheetsOpr.js',
        'public/web/storageUtil.js',
        'web/building_saas/complementary_ration_lib/js/coe.js'
    ],
    compleRation_inst_css: [
        'lib/jquery-contextmenu/jquery.contextMenu.css',
    ],
    compleRation_inst_jspaths: [
        'public/web/QueryParam.js',
        'public/web/uuid.js',
        'public/web/common_util.js',
        'public/web/storageUtil.js',
        'public/web/id_tree.js',
        'public/web/tree_sheet/tree_sheet_controller.js',
        'public/web/tree_sheet/tree_sheet_helper.js',
        'public/web/sheet/sheet_common.js',
        'public/web/common_ajax.js',
        'web/building_saas/complementary_ration_lib/js/global.js',
        'web/building_saas/complementary_ration_lib/js/installation.js'
    ]
}

