/**
 * Created by jimiz on 2017/4/18.
 */
let projectConst = {
    PROJECT: 'project',
    BILLS: 'bills',
    RATION: 'ration',
    GLJ: 'GLJ',
    RATION_GLJ:'ration_glj',
    RATION_COE:'ration_coe',
    RATION_ASS:'ration_ass',
    RATION_INSTALLATION:'ration_installation',
    RATION_TEMPLATE:'ration_template',
    QUANTITY_DETAIL:'quantity_detail',
    PROJECTGLJ: 'projectGLJ',
    GLJLIST: 'GLJList',
    UNITPRICEFILE: 'unitPriceFile',
    PROPERTIES: 'properties',
    // VOLUMEPRICE: 'volume_price',
    FEERATE:'feeRate',
    LABOUR_COE:'labour_coe',
    CALC_PROGRAM:'calc_program',
    INSTALLATION_FEE:'installation_fee',
    PROJECT_INFO: 'project_info',
    EVALUATE_LIST:'evaluate_list',
    CONTRACTOR_LIST:'contractor_list',
    BID_EVALUATION_LIST:'bid_evaluation_list'
};

let projectConstList = [
    'bills',
    'ration',
    'GLJ',
    'ration_glj',
    'ration_coe',
    'ration_ass',
    'quantity_detail',
    'projectGLJ',
    'GLJList',
    'unitPriceFile',
    'properties',
    // 'volume_price',
    'feeRate',
    'labour_coe',
    'calc_program'
];

let summaryConstList = [
    `Construct`,
    `ConstructDetail`,
    `Segment`,
    `SegmentDetail`
];

let projectFieldConstList = [
    `ProjectInfoFields`,        //工程信息指标
    `ProjectFeatureFields`,     //工程特征指标
    `ProjectCostFields`,        //工程造价指标
    `ProjectEcoFields`,         //工程（主要）经济指标
    `ProjectLabMaterialFields`, //主要工料指标
    `ProjectQtyFields`          //主要工程量指标
];

let commonConst = {
    UT_UPDATE: 'ut_update',
    UT_CREATE: 'ut_create',
    UT_DELETE: 'ut_delete'
};

const gljKeyArray =['code','name','specs','unit','type'];
const rationKeyArray =['code','name','specs','unit','subType'];
const rationType = {
    ration: 1,
    volumePrice: 2,
    gljRation: 3,
    install:4
};
module.exports = {
    projectConst: projectConst,
    commonConst: commonConst,
    projectConstList: projectConstList,
    gljKeyArray:gljKeyArray,
    rationKeyArray:rationKeyArray,
    rationType:rationType,
    summaryConstList: summaryConstList,
    projectFieldConstList: projectFieldConstList
};
