/**
 * Created by CSL on 2017-06-06.
 * public functions.
 */

function deleteEmptyObject(arr) {
    function isEmptyObject(e) {
        var t;
        for (t in e)
            return !1;
        return !0
    };

    for (var i = 0; i < arr.length; i++) {
        if (isEmptyObject(arr[i])) {
            arr.splice(i, 1);
            i = i - 1;
        };
    };
};

((factory) => {
    if (typeof module !== 'undefined') {
        module.exports = factory();
    } else {
        window.commonUtil = factory();
    }
})(() => {
    // 是否定义
    function isDef(val) {
        return typeof val !== 'undefined' && val !== null;
    }
    // 是否空值
    function isEmptyVal(val) {
        return val === null || val === undefined || val === '';
    }
    // 是否数值
    function isNumber(val) {
        return !isEmptyVal(val) && !isNaN(val);
    }
    // 是否近似相等(null = undefined = '', 1 = '1'...)
    function similarEqual(a, b) {
        // null == '' 为false，所以不能用非严等
        if (isEmptyVal(a) && isEmptyVal(b)) {
            return true;
        }
        return a == b;
    }

    return {
        isDef,
        isEmptyVal,
        isNumber,
        similarEqual,
    };
});
